const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const hashtags = sequelize.define(
    'hashtags',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

tag: {
        type: DataTypes.TEXT,
      
      

      },

is_blocked: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  hashtags.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.hashtags.hasMany(db.post_hashtags, {
      as: 'post_hashtags_hashtag',
      foreignKey: {
          name: 'hashtagId',
      },
      constraints: false,
    });


















//end loop






    db.hashtags.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.hashtags.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return hashtags;
};


